/*!
 * @file      NoteModel.h
 * @brief     NoteSend .
 * @author    Yangjae.park(yangjae.park@nhn.com)
 * @date      2012-02-21 
 * @warning    ۾Ϸ  XML üؾ Ѵ.  Json  
 */
#pragma once
#include "afxinet.h"

typedef enum
{
	MEMO_AUTH_NONE, 
	MEMO_AUTH_LARGE_FILE, 
	MEMO_AUTH_MANY_RECEIVER, 
	MEMO_AUTH_ALL,
}EMemoAuth;

#define	FILE_MAX_COUNT			10
#define FILE_MAX_DEFAULT		(30 * 1024 * 1024)
#define FILE_MAX_NT01			(500 * 1024 * 1024)
#define FILE_MAX_NT02			(10 * 1024 * 1024)

#define RECEIVER_MAX_DEFAULT	50
#define RECEIVER_MAX_NT01		10
#define RECEIVER_MAX_NT02		1000

#define SUCCESS_RECEIVER		0L
#define	FAIL_RECEIVER_OVER50	1L
#define FAIL_RECEIVER_OVER1000	2L
#define FAIL_RECEIVER_OVER10	3L

#define SUCCESS_FILE			0L
#define FAIL_FILE_OVER30		1L
#define FAIL_FILE_OVER500		2L
#define FAIL_FILE_OVER10		3L

class CNoteModel
{
public:
	CNoteModel(void);
	virtual ~CNoteModel(void);

public:
	BOOL				SendMemo(trid_t &trid);
	
	BOOL				AddNoteReceiver(CString strUserID, CString strUserName);
	void				RemoveNoteReceiver(CString strUserID);
	void				RemoveAllNoteReceiver();

	void				SetTicket(std::string strTicket){m_strTicket = strTicket;} 
	void				SetAttachID(CString strAttachID){m_strAttachID = strAttachID;}
	void				SetLanguage(CString strLanguage){m_strLanguage = strLanguage;}
	void				SetSubject(CString strSubject){m_strSubject = strSubject;}
	void				SetContent(CString strContent){m_strContent = strContent;}
	void				SetNoneTagContent(CString strNoneTagContent){m_strNoneTagContent = strNoneTagContent;}
	void				SetServerURL(CString strServerURL){m_strServerURL = strServerURL;}
	void				SetNotiCheck(BOOL bNoitIs){if(bNoitIs)m_strNotiCheck = _T("Y");else m_strNotiCheck = _T("N");}
	void				SetReservationCheck(BOOL bReservation){if(bReservation)m_strReservationCheck = _T("Y");else m_strReservationCheck = _T("N");}
	void				SetPartyCheck(BOOL bParty){if(bParty)m_strPartyCheck = _T("Y");else m_strPartyCheck = _T("N");}

	void				SetTimeZone(CString strTimeZone){m_strTimeZone = strTimeZone;}
	void				SetReservationTime(CString strRsvTime){m_strReservationTime=strRsvTime;}
	void				SetSendMaxUser(int nLimit){m_nSendMaxUser = nLimit;}
	void				SetNoteRecvTime(CString strRecvTime){m_strRecvTime=strRecvTime;}
	
	int					GetCurrentReceiverCount()
	{
		return m_receiverVector.size();
	}

	const std::string	GetAttachID() 
	{
		CT2CA convertString(m_strAttachID);
		std::string strRet(convertString);

		return strRet;
	}

	CString				GetReceiverIDs();
	CString				GetSubject(){return m_strSubject;}
	CString				GetContent(){return m_strContent;}
	int					GetSendMaxUser(){return m_nSendMaxUser;}
	//ULONGLONG			GetNoteBoxID(){return m_lNoteBoxID;}
	CString				GetNoteRecvTime(){return m_strRecvTime;}
	CString				GetNoteLastError(){return m_strLastError;}
	LRESULT				IsEnableReceiverUserCount(int nCurrentUser);
	LRESULT				IsEnableSendFileInfo(ULONGLONG ullFileSize);
	EMemoAuth			GetMemoAuth();
	LRESULT				EnableReceiverALL(int nCurrentUser);
	LRESULT				EnableReceiverLARGEFILE(int nCurrentUser);
	LRESULT				EnableReceiverMANYRECEIVER(int nCurrentUser);
	LRESULT				EnableReceiverNONE(int nCurrentUser);
	LRESULT				EnableFileALL(ULONGLONG ullFileSize);
	LRESULT				EnableFileLARGEFILE(ULONGLONG ullFileSize);
	LRESULT				EnableFileMANYRECEIVER(ULONGLONG ullFileSize);
	LRESULT				EnableFileNONE(ULONGLONG ullFileSize);

	std::vector<AttachFileInfo> m_attachFileInfoVector;

private:
	CString				m_strServerURL;			//  ּ
	std::string			m_strTicket;			// Ƽ 
	CString				m_strAttachID;			// Ƽ 
	CString				m_strLanguage;			// Lang 
	CString				m_strSenderID;			// ߽ ID;
	CStringArray		m_arReceiverID;			//  ID ;
	CString				m_strUserIDs;			//  û ̵𸮽Ʈ. |  Ѵ.
	CString				m_strSubject;			// 
	CString				m_strContent;			// 
	CString				m_strNoneTagContent;	//  Tag ų.
	CString				m_strNotiCheck;			// Ȯ
	CString				m_strReservationCheck;	// Y   N  Ϲ
	CString				m_strPartyCheck;		// Y   , N   .
	CString				m_strReservationTime;	// ۽ð
	CString				m_strTimeZone;			// ðڵ
	int					m_nSendMaxUser;			// ִ ÿ   ִ  
	//ULONGLONG			m_lNoteBoxID;			//   ID
	SenderInfo			m_SenderInfo;			// .
	CString				m_strRecvTime;			//   ð
	CString				m_strLastError;			// ޽.
	std::string			m_attachID;

public:
	NT_NOTE_SEND_DATA	m_sSendNoteData;


protected:
	std::vector<ReceiverInfo> m_receiverVector;

private:
	BOOL				MakeNoteBox(std::string strJsonDoc);
	void				RequestPostData(CHttpFile* pHTTP, CString strFormData);
	void				SetLastError(CString strErr){m_strLastError = strErr;}
	void				MakeSendFormData(std::string &strFormData);
	void				MakeSendNoteData(NT_NOTE_SEND_DATA &sSendNoteData);
	
};
